﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TxClientApp.ManualTxService;

namespace TxClientApp
{
	public partial class TxClientForm : Form
	{
		TxServiceClient _proxy;

		public TxClientForm()
		{
			InitializeComponent();

			btnOpenService.Enabled = true;
			btnInsertData.Enabled = false;
			btnSetComplete.Enabled = false;
			btnCloseService.Enabled = false;
			btnGetData.Enabled = true;
		}

		private void btnOpenService_Click(object sender, EventArgs e)
		{
			_proxy = new TxServiceClient();
			_proxy.Open();
			btnOpenService.Enabled = false;
			btnInsertData.Enabled = true;
			btnSetComplete.Enabled = true;
			btnCloseService.Enabled = true;
			btnGetData.Enabled = true;
		}

		private void btnInsertData_Click(object sender, EventArgs e)
		{
			int ret = _proxy.InsertData(0);
			btnGetData.Enabled = false;
			MessageBox.Show("Inserted Data ID = " + ret.ToString(), "Service Result",
				MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		private void btnSetComplete_Click(object sender, EventArgs e)
		{
			_proxy.SetComplete();
			btnGetData.Enabled = true;
		}

		private void btnCloseService_Click(object sender, EventArgs e)
		{
			(_proxy as IDisposable).Dispose();
			_proxy = null;
			btnOpenService.Enabled = true;
			btnInsertData.Enabled = false;
			btnSetComplete.Enabled = false;
			btnCloseService.Enabled = false;
			btnGetData.Enabled = true;
		}

		// 트랜잭션이 진행 중인 동안 데이터를 조회하면 트랜잭션이 완료될 때까지
		// 조회 쿼리는 블록되어 버린다. 따라서 데이터 조회는 트랜잭션이 진행되는
		// 동안 호출되어서는 안된다.
		private void btnGetData_Click(object sender, EventArgs e)
		{
			DataSet ds;

			dataGridView1.DataSource = null;
			using (TxServiceClient proxy = new TxServiceClient()) {
				ds = proxy.GetData();
			}
			dataGridView1.DataSource = ds.Tables[0];
		}
	}
}
