﻿using System;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace DLQProcessServiceApp
{
	[ServiceContract]
	interface IMsmqService
	{
		[OperationContract(IsOneWay = true)]
		void TestMethod(string arg);
	}

	[ServiceBehavior(AddressFilterMode = AddressFilterMode.Any)]
	class DLQProcessService : IMsmqService
	{
		public void TestMethod(string arg)
		{
			OperationContext ctx = OperationContext.Current;
			MsmqMessageProperty prop =
				(MsmqMessageProperty)ctx.IncomingMessageProperties[MsmqMessageProperty.Name];
			Console.WriteLine("Message Info: status={0}  failure={1}",
				prop.DeliveryStatus, prop.DeliveryFailure);
			Console.WriteLine("  arg = {0}", arg);
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("DLQ Processing Service Sample......");

			NetMsmqBinding binding = new NetMsmqBinding();
			binding.Security.Mode = NetMsmqSecurityMode.None;

			ServiceHost host = new ServiceHost(typeof(DLQProcessService),
				new Uri("net.msmq://localhost/system$;deadxact"));
			host.AddServiceEndpoint(typeof(IMsmqService), binding, "");

			host.Open();
			Console.WriteLine("The service started... Press any key to stop...");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
