﻿using System;
using System.ServiceModel;
using HelloWorldService;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;

namespace HelloWorldHost
{
	//
	// Hello World 서비스에 대한 WCF 호스트 구현
	//
	class HostApp
	{
		static void Main(string[] args)
		{
			//
			// 테스트 마다 다음 호스트 호출 중 하나를 사용하고 나머지는 주석으로
			// 막아야 한다.
			//
			AdvancedHost();
			//AdvancedHost2();
		}

		// configuration을 사용하는 서비스 호스트 예제 코드
		static void AdvancedHost()
		{
			// 다음 코드가 정상적으로 작동하기 위해서는 app.config 파일의
			// <services> 요소가 정상적인 설정으로 남아 있어야 한다.
			// 이 요소가 comment로 막혀 있다면 comment를 제거하도록 한다.
			ServiceHost host = new ServiceHost(typeof(HelloWorldWCFService));

			host.Open();
			Console.WriteLine("Press Any key to stop the service");
			Console.ReadKey(true);
			host.Close();
		}

		// configuration 설정을 override 하는 예제 코드
		static void AdvancedHost2()
		{
			// 다음 코드에서 configuration을 읽어 ServiceHost를 초기화 한다.
			ServiceHost host = new ServiceHost(typeof(HelloWorldWCFService));
			// configuration 설정에 의해 초기화된 설정을 코드에 의해
			// 변경할 수 있다.
			foreach (ServiceEndpoint ep in host.Description.Endpoints) {
				BasicHttpBinding binding = ep.Binding as BasicHttpBinding;
				if (binding != null) {
					binding.MessageEncoding = WSMessageEncoding.Mtom;
				}
			}

			// ServiceMetadataBehavior 설정
			ServiceMetadataBehavior behavior =
				host.Description.Behaviors.Find<ServiceMetadataBehavior>();
			if (behavior == null) {
				behavior = new ServiceMetadataBehavior();
				host.Description.Behaviors.Add(behavior);
			}
			behavior.HttpGetEnabled = true;

			host.Open();
			Console.WriteLine("Press Any key to stop the service");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
