﻿using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Remoting.Channels.Ipc;

namespace RemotingHost
{
	class Program
	{
		//
		// 닷넷 리모팅의 서비스 호스팅 프로그램
		//
		static void Main(string[] args)
		{
			Console.WriteLine("Sample .NET Remoting Host Application...");

			// 리모팅 채널로써 TCP와 HTTP, IPC를 모두 사용한다.
			TcpChannel tcpChannel = new TcpChannel(8080);
			HttpChannel httpChannel = new HttpChannel(8088);
			IpcChannel ipcChannel = new IpcChannel("localhost:8089");
			ChannelServices.RegisterChannel(tcpChannel, false);
			ChannelServices.RegisterChannel(httpChannel, false);
			ChannelServices.RegisterChannel(ipcChannel, false);

			// 리모팅을 통해 액세스될 타입을 등록한다.
			RemotingConfiguration.RegisterWellKnownServiceType(
				typeof(RemotingService.HelloWorldService),
				"HelloWorldService.rem",
				WellKnownObjectMode.SingleCall);
			RemotingConfiguration.RegisterWellKnownServiceType(
				typeof(RemotingService.HelloWorldService2),
				"HelloWorldService2.rem",
				WellKnownObjectMode.SingleCall);

			// 채널 리스닝 등은 리모팅 프레임워크에 의해 자동적으로 수행된다.

			Console.WriteLine("Press Any Key for Stop......");
			Console.ReadKey();
		}
	}
}
