﻿using System;
using System.Data;

using MiscDataContractClient.Test;

namespace MiscDataContractClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Miscellaneous Data Contract Client Example...");

			using (MiscServiceClient proxy = new MiscServiceClient()) {
				MyEnum ret = proxy.GetEnum();
				Console.WriteLine("Enum result = {0} [{1}]", ret, (int)ret);

				DataSet ds = proxy.GetDataSet();
				Console.WriteLine("GetDataSet Result : {0} tables", ds.Tables.Count);
				foreach (DataTable table in ds.Tables) {
					Console.WriteLine("  Records in '{0}' : {1}", 
						table.TableName, table.Rows.Count);
				}

				DataTable dt = proxy.GetDataTable();
				Console.WriteLine("GetDataTable Result : {0} rows", dt.Rows.Count);

				ProductDataSet ds2 = proxy.GetTypedDataSet();
				Console.WriteLine("GetTypedDataSet Result : table name = {0}, row = {1}",
					ds2.Products.TableName, ds2.Products.Count);

				ProductDataSet.ProductsDataTable dt2 = proxy.GetTypedDataTable();
				Console.WriteLine("GetTypedDataTable Result : table name = {0}, row = {1}",
					dt2.TableName, dt2.Count);
			}
		}
	}
}
