﻿using System;
using System.Collections.Generic;
using System.Text;

using SerializationEventClient.BookStore;

namespace SerializationEventClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Serialization Event Client Example ......");

			BookInfo info = new BookInfo();
			info.Isbn = "001-100";
			info.Title = "간단한 것이 좋은 것이다";
			info.Price = 12000;
			info.Author = null;

			using (ManageBooksClient proxy = new ManageBooksClient()) {
				proxy.AddBook(info);
				BookInfo info2 = proxy.GetBookInfo("001-100");
				Console.WriteLine("Book Information:\n  Title={0}\n  Author={1}\n  ISBN={2}\n  Price={3:#,##0} Won",
					info2.Title, info2.Author, info2.Isbn, info2.Price);
			}
		}
	}
}
