﻿using System;
using System.ServiceModel;

using ConfigureBindingClient.BookStore;

namespace ConfigureBindingClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("BookStore Client Application");

			// 코드에 의한 바인딩 설정
			WSHttpBinding binding = new WSHttpBinding();
			binding.MessageEncoding = WSMessageEncoding.Mtom;
			binding.TransactionFlow = true;
			binding.ReliableSession.Enabled = true;

			EndpointAddress remoteAddress = new EndpointAddress(
				"http://loner/wcf/example/bookstoreservice");

			// VS 2005의 서비스 참조를 이용하여 클라이언트 프록시 코드를 생성하였고
			// 자동 생성된 바인딩 설정이나 Endpoint 설정은 사용하지 않았다.
			int orderid;
			using (BookStoreClient proxy = new BookStoreClient(binding, remoteAddress)) {
				orderid = proxy.Order("GoPl", "999-9-999-99999-9", 2);
				Console.WriteLine("Place Order. Order ID = {0}", orderid);
			}
		}
	}
}
