﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace CustomizingWSHttpBindingService
{
	// 간단한 Echo 서비스 계약
	[ServiceContract]
	interface IMyContract
	{
		[OperationContract]
		string Echo(string arg);
	}

	// 서비스 구현 클래스
	[ServiceBehavior(IncludeExceptionDetailInFaults = true)]
	class MyService : IMyContract
	{
		public string Echo(string arg)
		{
			// 말그대로 에코만... ^^
			return arg;
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Customizing WSHttpBinding Sample Service......");

			ServiceHost host = new ServiceHost(typeof(MyService),
				new Uri("http://localhost/wcf/example/myservice"));

			// WSDL에 대한 HTTP GET을 enable
			ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
			behavior.HttpGetEnabled = true;
			host.Description.Behaviors.Add(behavior);

			// 서비스 리스너 구동 및 서비스 수행
			host.Open();
			Console.WriteLine("Press Any Key to Stop Service......");
			Console.ReadKey(true);

			// 서비스 종료
			host.Close();
		}
	}
}
