﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FileMgrClientApp.FileMgrService;
using System.IO;

namespace FileMgrClientApp
{
	public partial class ImageForm : Form
	{
		public ImageForm()
		{
			InitializeComponent();
			cbxImages.SelectedIndex = 0;
			cbxBindings.SelectedIndex = 0;
		}

		private void btnGetImage_Click(object sender, EventArgs e)
		{
			int bindingIndex = cbxBindings.SelectedIndex;
			byte[] buffer = null;

			switch (bindingIndex) {
			case 0:
				buffer = GetImageData("HttpTextEncoding");
				break;
			case 1:
				buffer = GetImageData("HttpMtomEncoding");
				break;
			case 2:
				buffer = GetImageData("HttpBinaryEncoding");
				break;
			case 3:
				buffer = GetImageData("TcpBinaryEncoding");
				break;
			}

			lblSize.Text = String.Format("Size: {0:#,###,##0}", buffer.Length);

			MemoryStream stream = new MemoryStream(buffer);
			Image img = Image.FromStream(stream);
			picImage.Image = img;
		}

		private byte[] GetImageData(string configurationName)
		{
			string filename = (string)cbxImages.SelectedItem;
			using (FileMgrClient proxy = new FileMgrClient(configurationName)) {
				byte[] buffer = proxy.GetImageFile(filename);
				return buffer;
			}
		}
	}
}