﻿using System;
using System.ServiceModel;
using System.Runtime.Serialization;
using System.ServiceModel.Description;

namespace TestServiceApp
{
	// 서비스 계약 선언
	[ServiceContract]
	interface IMyContract
	{
		[OperationContract]
		void MyMethod(MyData data);
	}

	// 데이터 계약 선언
	[DataContract]
	class MyData
	{
		[DataMember]
		public string Field;
	}

	// 서비스 구현
	class MyService : IMyContract
	{
		public void MyMethod(MyData data)
		{
			Console.WriteLine("MyMethod() : MyData.Field={0}", data.Field);
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Simple Service for writing WCF Client......");

			ServiceHost host = new ServiceHost(typeof(MyService),
				new Uri("http://localhost/wcf/example/testservice"));
			BasicHttpBinding binding = new BasicHttpBinding();
			host.AddServiceEndpoint(typeof(IMyContract), binding, "");
			ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
			behavior.HttpGetEnabled = true;
			host.Description.Behaviors.Add(behavior);

			host.Open();
			Console.WriteLine("Press any key to stop the service.....");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
