﻿using System;
using System.ServiceModel;

namespace MultipleServiceApp
{
	#region "서비스 계약 선언 목록"

	[ServiceContract]
	interface IMyContract1
	{
		[OperationContract]
		string MyMethod1();
	}

	[ServiceContract]
	interface IMyContract2
	{
		[OperationContract]
		string MyMethod2();
	}

	[ServiceContract]
	interface IMyContract3
	{
		[OperationContract]
		string MyMethod3();
	}
	#endregion

	#region "서비스 구현"

	class MyService1 : IMyContract1
	{
		public string MyMethod1()
		{
			Console.WriteLine("MyService1.MyMethod1() invoked......");
			return "MyMethod1";
		}
	}

	class MyService2 : IMyContract2, IMyContract3
	{
		public string MyMethod2()
		{
			Console.WriteLine("MyService2.MyMethod2() invoked......");
			return "MyMethod2";
		}

		public string MyMethod3()
		{
			Console.WriteLine("MyService3.MyMethod2() invoked......");
			return "MyMethod3";
		}
	}
	#endregion

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Multiple Service Hosting Sample......");
			Console.WriteLine();
			// 서비스 호스트 셋업
			ServiceHost host1 = new ServiceHost(typeof(MyService1),
				new Uri("http://localhost/wcf/example/multiservice1"));
			host1.OpenTimeout = TimeSpan.FromSeconds(30);
			host1.CloseTimeout = TimeSpan.FromSeconds(30);

			ServiceHost host2 = new ServiceHost(typeof(MyService2));
			Console.WriteLine("OpenTimeout : {0}", host2.OpenTimeout);
			Console.WriteLine("CloseTimeout : {0}", host2.CloseTimeout);
			// 서비스 호스트 Open
			host1.Open();
			Console.WriteLine("ServiceHost for MyService1 is open...");
			host2.Open();
			Console.WriteLine("ServiceHost for MyService2 is open...");
			Console.WriteLine("Press any key to stop the services...");
			Console.ReadKey(true);
			// 호스트 Close
			host1.Close();
			host2.Close();
		}
	}
}
