﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;

namespace ExceptionServiceApp
{
	// 서비스 Behavior 구현
	class MyErrorHandlerBehavior : IServiceBehavior
	{
		private bool _Enabled = true;

		public bool Enabled
		{
			get { return _Enabled; }
			set { _Enabled = value; }
		}

		public void AddBindingParameters(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase, System.Collections.ObjectModel.Collection<ServiceEndpoint> endpoints, BindingParameterCollection bindingParameters)
		{
		}

		public void ApplyDispatchBehavior(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase)
		{
			if (_Enabled) {
				MyErrorHandler handler = new MyErrorHandler();
				foreach (ChannelDispatcher dispatcher in serviceHostBase.ChannelDispatchers) {
					dispatcher.ErrorHandlers.Add(handler);
				}
			}
		}

		public void Validate(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase)
		{
		}
	}
}
