﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;

namespace ServiceWithUI
{
	public partial class ServiceUIForm : Form
	{
		public ServiceUIForm()
		{
			InitializeComponent();

			ServiceHost host = new ServiceHost(typeof(LogService),
				new Uri("http://localhost/wcf/example/winformhost/logservice"));
			this.Load += delegate(object sender, EventArgs e) {
				host.Open();
			};
			this.FormClosed += delegate(object sender, FormClosedEventArgs e) {
				host.Close();
			};
		}

		public void ShowLogMessage(int count, string message)
		{
			MethodInvoker func = delegate() {
				lblCallCount.Text = count.ToString();
				string log = String.Format("[{0}] {1}", count, message);
				int index = lbxLogs.Items.Add(log);
				lbxLogs.SelectedIndex = index;
			};
			if (this.InvokeRequired == true) {
				this.Invoke(func);
			}
			else {
				func();
			}
		}
	}
}
