﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SessionfulClientApp.EnumDataService;

namespace SessionfulClientApp
{
	public partial class ClientForm : Form
	{
		private EnumDataClient _Proxy = null;

		public ClientForm()
		{
			InitializeComponent();
		}

		// 데이터를 리스트 박스에 표시한다.
		private void ShowData(BindingList<string> data)
		{
			if (data != null) {
				lbData.DataSource = data;
			}
		}

		private void ClientForm_Load(object sender, EventArgs e)
		{
			// 프록시를 생성하고 세션을 연다.
			_Proxy = new EnumDataClient("WSHttpBinding_IEnumData");
			// 초기 데이터를 읽는다.
			_Proxy.OpenEnum();
			BindingList<string> data = _Proxy.GetNext();
			ShowData(data);
		}

		private void btnPrev_Click(object sender, EventArgs e)
		{
			// 다음 데이터를 읽어 표시한다.
			BindingList<string> data = _Proxy.GetPrevious();
			ShowData(data);
		}

		private void btnNext_Click(object sender, EventArgs e)
		{
			// 이전 데이터를 읽어 표시한다.
			BindingList<string> data = _Proxy.GetNext();
			ShowData(data);
		}

		private void ClientForm_FormClosing(object sender, FormClosingEventArgs e)
		{
			// 데이터 열거를 마치고 프록시를 닫는다.
			_Proxy.CloseEnum();
			_Proxy.Close();
		}
	}
}