﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.ServiceModel;

namespace TestServiceApp
{
	[ServiceContract]
	interface IPerSessionService
	{
		[OperationContract]
		void TestMethod(int delay);
	}

	[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession)]
	class PerSessionService : IPerSessionService, IDisposable
	{
		private static int _ObjectCount = 0;

		public PerSessionService()
		{
			Interlocked.Increment(ref _ObjectCount);
			Console.WriteLine("++ PerSessionService object created, count={0}", _ObjectCount);
		}

		public void Dispose()
		{
			Interlocked.Decrement(ref _ObjectCount);
			Console.WriteLine("-- PerSessionService object released, count={0}", _ObjectCount);
		}

		public void TestMethod(int delay)
		{
			Thread.Sleep(delay);
		}
	}
}
