﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.Threading;

namespace TestServiceApp
{

	[ServiceContract]
	interface ILog
	{
		[OperationContract]
		int LogMessage(string message);

		[OperationContract]
		void LogMessageWithError();
	}

	[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
	class LogService : ILog
	{
		private static int _CallCount = 0;

		public int LogMessage(string message)
		{
			int logId = Interlocked.Increment(ref _CallCount);
			Console.WriteLine("[{0}] Log: {1}", logId, message);
			Thread.Sleep(10000);
			return logId;
		}

		public void LogMessageWithError()
		{
			Console.WriteLine("InvalidOperationException will be thrown");

			InvalidOperationException ex = new InvalidOperationException("테스트를 위한 강제 예외");
			throw new FaultException<ExceptionDetail>(new ExceptionDetail(ex));
		}
	}
}
